diff --git a/lib/librte_eal/common/eal_common_trace_points.c b/lib/librte_eal/common/eal_common_trace_points.c
new file mode 100644
index 000000000..ff521c981
--- /dev/null
+++ b/lib/librte_eal/common/eal_common_trace_points.c
@@ -0,0 +1,60 @@
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright(C) 2020 Marvell International Ltd.
+ */
+
+#define RTE_TRACE_POINT_REGISTER_SELECT /* Select trace point register macros */
+
+#include <rte_trace_eal.h>
+
+RTE_TRACE_POINT_DEFINE(rte_trace_lib_eal_generic_void);
+RTE_TRACE_POINT_DEFINE(rte_trace_lib_eal_generic_u64);
+RTE_TRACE_POINT_DEFINE(rte_trace_lib_eal_generic_u32);
+RTE_TRACE_POINT_DEFINE(rte_trace_lib_eal_generic_u16);
+RTE_TRACE_POINT_DEFINE(rte_trace_lib_eal_generic_u8);
+RTE_TRACE_POINT_DEFINE(rte_trace_lib_eal_generic_i64);
+RTE_TRACE_POINT_DEFINE(rte_trace_lib_eal_generic_i32);
+RTE_TRACE_POINT_DEFINE(rte_trace_lib_eal_generic_i16);
+RTE_TRACE_POINT_DEFINE(rte_trace_lib_eal_generic_i8);
+RTE_TRACE_POINT_DEFINE(rte_trace_lib_eal_generic_int);
+RTE_TRACE_POINT_DEFINE(rte_trace_lib_eal_generic_long);
+RTE_TRACE_POINT_DEFINE(rte_trace_lib_eal_generic_float);
+RTE_TRACE_POINT_DEFINE(rte_trace_lib_eal_generic_double);
+RTE_TRACE_POINT_DEFINE(rte_trace_lib_eal_generic_ptr);
+RTE_TRACE_POINT_DEFINE(rte_trace_lib_eal_generic_str);
+RTE_TRACE_POINT_DEFINE(rte_trace_lib_eal_generic_func);
+
+RTE_INIT(eal_trace_init)
+{
+	RTE_TRACE_POINT_REGISTER(rte_trace_lib_eal_generic_void,
+				 lib.eal.generic.void, INFO);
+	RTE_TRACE_POINT_REGISTER(rte_trace_lib_eal_generic_u64,
+				 lib.eal.generic.u64, INFO);
+	RTE_TRACE_POINT_REGISTER(rte_trace_lib_eal_generic_u32,
+				 lib.eal.generic.u32, INFO);
+	RTE_TRACE_POINT_REGISTER(rte_trace_lib_eal_generic_u16,
+				 lib.eal.generic.u16, INFO);
+	RTE_TRACE_POINT_REGISTER(rte_trace_lib_eal_generic_u8,
+				 lib.eal.generic.u8, INFO);
+	RTE_TRACE_POINT_REGISTER(rte_trace_lib_eal_generic_i64,
+				 lib.eal.generic.i64, INFO);
+	RTE_TRACE_POINT_REGISTER(rte_trace_lib_eal_generic_i32,
+				 lib.eal.generic.i32, INFO);
+	RTE_TRACE_POINT_REGISTER(rte_trace_lib_eal_generic_i16,
+				 lib.eal.generic.i16, INFO);
+	RTE_TRACE_POINT_REGISTER(rte_trace_lib_eal_generic_i8,
+				 lib.eal.generic.i8, INFO);
+	RTE_TRACE_POINT_REGISTER(rte_trace_lib_eal_generic_int,
+				 lib.eal.generic.int, INFO);
+	RTE_TRACE_POINT_REGISTER(rte_trace_lib_eal_generic_long,
+				 lib.eal.generic.long, INFO);
+	RTE_TRACE_POINT_REGISTER(rte_trace_lib_eal_generic_float,
+				 lib.eal.generic.float, INFO);
+	RTE_TRACE_POINT_REGISTER(rte_trace_lib_eal_generic_double,
+				 lib.eal.generic.double, INFO);
+	RTE_TRACE_POINT_REGISTER(rte_trace_lib_eal_generic_ptr,
+				 lib.eal.generic.ptr, INFO);
+	RTE_TRACE_POINT_REGISTER(rte_trace_lib_eal_generic_str,
+				 lib.eal.generic.string, INFO);
+	RTE_TRACE_POINT_REGISTER(rte_trace_lib_eal_generic_func,
+				 lib.eal.generic.func, INFO);
+}
diff --git a/lib/librte_eal/common/meson.build b/lib/librte_eal/common/meson.build
index d2ac44313..155da29b4 100644
--- a/lib/librte_eal/common/meson.build
+++ b/lib/librte_eal/common/meson.build
@@ -44,6 +44,7 @@ sources += files(
 	'eal_common_timer.c',
 	'eal_common_trace.c',
 	'eal_common_trace_ctf.c',
+	'eal_common_trace_points.c',
 	'eal_common_trace_utils.c',
 	'eal_common_uuid.c',
 	'hotplug_mp.c',
diff --git a/lib/librte_eal/freebsd/Makefile b/lib/librte_eal/freebsd/Makefile
index 539ad44a7..a8400f20a 100644
--- a/lib/librte_eal/freebsd/Makefile
+++ b/lib/librte_eal/freebsd/Makefile
@@ -61,6 +61,7 @@ SRCS-$(CONFIG_RTE_EXEC_ENV_FREEBSD) += eal_common_fbarray.c
 SRCS-$(CONFIG_RTE_EXEC_ENV_FREEBSD) += eal_common_uuid.c
 SRCS-$(CONFIG_RTE_EXEC_ENV_FREEBSD) += eal_common_trace.c
 SRCS-$(CONFIG_RTE_EXEC_ENV_FREEBSD) += eal_common_trace_ctf.c
+SRCS-$(CONFIG_RTE_EXEC_ENV_FREEBSD) += eal_common_trace_points.c
 SRCS-$(CONFIG_RTE_EXEC_ENV_FREEBSD) += eal_common_trace_utils.c
 SRCS-$(CONFIG_RTE_EXEC_ENV_FREEBSD) += rte_malloc.c
 SRCS-$(CONFIG_RTE_EXEC_ENV_FREEBSD) += hotplug_mp.c
diff --git a/lib/librte_eal/include/meson.build b/lib/librte_eal/include/meson.build
index 037a4ae63..57b7f25c8 100644
--- a/lib/librte_eal/include/meson.build
+++ b/lib/librte_eal/include/meson.build
@@ -41,6 +41,7 @@ headers += files(
 	'rte_tailq.h',
 	'rte_time.h',
 	'rte_trace.h',
+	'rte_trace_eal.h',
 	'rte_trace_provider.h',
 	'rte_trace_register.h',
 	'rte_uuid.h',
diff --git a/lib/librte_eal/include/rte_trace_eal.h b/lib/librte_eal/include/rte_trace_eal.h
new file mode 100644
index 000000000..269ef7502
--- /dev/null
+++ b/lib/librte_eal/include/rte_trace_eal.h
@@ -0,0 +1,122 @@
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright(C) 2020 Marvell International Ltd.
+ */
+
+#ifndef _RTE_TRACE_EAL_H_
+#define _RTE_TRACE_EAL_H_
+
+/**
+ * @file
+ *
+ * API for EAL trace support
+ */
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <rte_trace.h>
+
+/* Generic */
+RTE_TRACE_POINT(
+	rte_trace_lib_eal_generic_void,
+	RTE_TRACE_POINT_ARGS(void),
+)
+
+RTE_TRACE_POINT(
+	rte_trace_lib_eal_generic_u64,
+	RTE_TRACE_POINT_ARGS(uint64_t in),
+	rte_trace_ctf_u64(in);
+)
+
+RTE_TRACE_POINT(
+	rte_trace_lib_eal_generic_u32,
+	RTE_TRACE_POINT_ARGS(uint32_t in),
+	rte_trace_ctf_u32(in);
+)
+
+RTE_TRACE_POINT(
+	rte_trace_lib_eal_generic_u16,
+	RTE_TRACE_POINT_ARGS(uint16_t in),
+	rte_trace_ctf_u16(in);
+)
+
+RTE_TRACE_POINT(
+	rte_trace_lib_eal_generic_u8,
+	RTE_TRACE_POINT_ARGS(uint8_t in),
+	rte_trace_ctf_u8(in);
+)
+
+RTE_TRACE_POINT(
+	rte_trace_lib_eal_generic_i64,
+	RTE_TRACE_POINT_ARGS(int64_t in),
+	rte_trace_ctf_i64(in);
+)
+
+RTE_TRACE_POINT(
+	rte_trace_lib_eal_generic_i32,
+	RTE_TRACE_POINT_ARGS(int32_t in),
+	rte_trace_ctf_i32(in);
+)
+
+RTE_TRACE_POINT(
+	rte_trace_lib_eal_generic_i16,
+	RTE_TRACE_POINT_ARGS(int16_t in),
+	rte_trace_ctf_i16(in);
+)
+
+RTE_TRACE_POINT(
+	rte_trace_lib_eal_generic_i8,
+	RTE_TRACE_POINT_ARGS(int8_t in),
+	rte_trace_ctf_i8(in);
+)
+
+RTE_TRACE_POINT(
+	rte_trace_lib_eal_generic_int,
+	RTE_TRACE_POINT_ARGS(int in),
+	rte_trace_ctf_int(in);
+)
+
+RTE_TRACE_POINT(
+	rte_trace_lib_eal_generic_long,
+	RTE_TRACE_POINT_ARGS(long in),
+	rte_trace_ctf_long(in);
+)
+
+RTE_TRACE_POINT(
+	rte_trace_lib_eal_generic_float,
+	RTE_TRACE_POINT_ARGS(float in),
+	rte_trace_ctf_float(in);
+)
+
+RTE_TRACE_POINT(
+	rte_trace_lib_eal_generic_double,
+	RTE_TRACE_POINT_ARGS(double in),
+	rte_trace_ctf_double(in);
+)
+
+RTE_TRACE_POINT(
+	rte_trace_lib_eal_generic_ptr,
+	RTE_TRACE_POINT_ARGS(const void *ptr),
+	rte_trace_ctf_ptr(ptr);
+)
+
+RTE_TRACE_POINT(
+	rte_trace_lib_eal_generic_str,
+	RTE_TRACE_POINT_ARGS(const char *str),
+	rte_trace_ctf_string(str);
+)
+
+RTE_TRACE_POINT(
+	rte_trace_lib_eal_generic_func,
+	RTE_TRACE_POINT_ARGS(const char *func),
+	rte_trace_ctf_string(func);
+)
+
+#define RTE_TRACE_LIB_EAL_GENERIC_FUNC rte_trace_lib_eal_generic_func(__func__)
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* _RTE_TRACE_EAL_H_ */
diff --git a/lib/librte_eal/linux/Makefile b/lib/librte_eal/linux/Makefile
index f00588d6e..a77eb1757 100644
--- a/lib/librte_eal/linux/Makefile
+++ b/lib/librte_eal/linux/Makefile
@@ -68,6 +68,7 @@ SRCS-$(CONFIG_RTE_EXEC_ENV_LINUX) += eal_common_fbarray.c
 SRCS-$(CONFIG_RTE_EXEC_ENV_LINUX) += eal_common_uuid.c
 SRCS-$(CONFIG_RTE_EXEC_ENV_LINUX) += eal_common_trace.c
 SRCS-$(CONFIG_RTE_EXEC_ENV_LINUX) += eal_common_trace_ctf.c
+SRCS-$(CONFIG_RTE_EXEC_ENV_LINUX) += eal_common_trace_points.c
 SRCS-$(CONFIG_RTE_EXEC_ENV_LINUX) += eal_common_trace_utils.c
 SRCS-$(CONFIG_RTE_EXEC_ENV_LINUX) += rte_malloc.c
 SRCS-$(CONFIG_RTE_EXEC_ENV_LINUX) += hotplug_mp.c
diff --git a/lib/librte_eal/rte_eal_version.map b/lib/librte_eal/rte_eal_version.map
index 36163287e..de33e08f0 100644
--- a/lib/librte_eal/rte_eal_version.map
+++ b/lib/librte_eal/rte_eal_version.map
@@ -365,4 +365,21 @@ EXPERIMENTAL {
 	rte_trace_save;
 	rte_trace_metadata_dump;
 	rte_trace_dump;
+
+	__rte_trace_lib_eal_generic_void;
+	__rte_trace_lib_eal_generic_u64;
+	__rte_trace_lib_eal_generic_u32;
+	__rte_trace_lib_eal_generic_u16;
+	__rte_trace_lib_eal_generic_u8;
+	__rte_trace_lib_eal_generic_i64;
+	__rte_trace_lib_eal_generic_i32;
+	__rte_trace_lib_eal_generic_i16;
+	__rte_trace_lib_eal_generic_i8;
+	__rte_trace_lib_eal_generic_int;
+	__rte_trace_lib_eal_generic_long;
+	__rte_trace_lib_eal_generic_float;
+	__rte_trace_lib_eal_generic_double;
+	__rte_trace_lib_eal_generic_ptr;
+	__rte_trace_lib_eal_generic_str;
+	__rte_trace_lib_eal_generic_func;
 };